CKEDITOR.plugins.add( 'bor',
{
	init: function( editor )
	{
		editor.addCommand( 'borCommand', new CKEDITOR.dialogCommand( 'borDialog' ) );
		editor.ui.addButton( 'bor',
			{
				label: 'لإدراج نص داخل جدول متقطع بخيار اللون',
				command: 'borCommand',
				icon: this.path + 'bor.gif'
			}
		);
		
		function getDialogValue( dialogName, callback )
		{
			var onOk = function()
			{
				releaseHandlers( this );
				callback( this, this._.parentDialog );
				this._.parentDialog.changeFocus( true );
			};
			var onCancel = function()
			{
				releaseHandlers( this );
				this._.parentDialog.changeFocus();
			};
			var releaseHandlers = function( dialog )
			{
				dialog.removeListener( 'ok', onOk );
				dialog.removeListener( 'cancel', onCancel );
			};
			var bindToDialog = function( dialog )
			{
				dialog.on( 'ok', onOk );
				dialog.on( 'cancel', onCancel );
			};
			editor.execCommand( dialogName );
			if ( editor._.storedDialogs.colordialog )
				bindToDialog( editor._.storedDialogs.colordialog );
			else
			{
				CKEDITOR.on( 'dialogDefinition', function( e )
				{
					if ( e.data.name != dialogName )
						return;

					var definition = e.data.definition;

					e.removeListener();
					definition.onLoad = CKEDITOR.tools.override( definition.onLoad, function( orginal )
					{
						return function()
						{
							bindToDialog( this );
							definition.onLoad = orginal;
							if ( typeof orginal == 'function' )
								orginal.call( this );
						};
					} );
				});
			}
		}

		var data = {};
		CKEDITOR.dialog.add( 'borDialog', function( editor )
		{
			return {
				title : 'لإدراج نص داخل جدول متقطع بخيار اللون',
				width : 400,
				height : 'auto',
				onShow : function (){
					if  (editor.getSelection().getSelectedText().length < 1) {
						alert('رجاء تحديد النص اولا');
							if ( this.fire( 'cancel', { hide : true } ).hide !== false ){
								this.hide();
								evt.data.preventDefault();
							}
						return;
					} else {
						data.selected = editor.getSelection().getSelectedText();
					}
				},
				contents :
				[
					{
						id : 'bor',
						label : 'اختيار اللون',
						elements :
						[
							{
								type : 'text',
								id : 'color',
								label : 'اللون',
								default:'black',
								style: 'width:100px;float:right',
								validate : CKEDITOR.dialog.validate.notEmpty( 'رجاء اختيار اللون' ),
								required : false,
								onClick : function()
								{
									var self = this;
									getDialogValue( 'colordialog', function( colorDialog )
									{
										self.getDialog().getContentElement( 'bor', 'color' ).setValue(
											colorDialog.getContentElement( 'picker', 'selectedColor' ).getValue()
										);
									} );
								},
								commit : function( data )
								{
									data.color = this.getValue();
								}
							},
							{
								type : 'button',
								id : 'buttonId',
								label : 'اختر اللون',
								title : 'اختر اللون',
								onClick : function()
								{
									var self = this;
									getDialogValue( 'colordialog', function( colorDialog )
									{
										self.getDialog().getContentElement( 'bor', 'color' ).setValue(
											colorDialog.getContentElement( 'picker', 'selectedColor' ).getValue()
										);
									} );
								}
							},
							{
								type : 'textarea',
								id : 'text',
								label : 'النص المحدد',
								default:'النص',
								validate : CKEDITOR.dialog.validate.notEmpty( 'لا يمكنك ترك حقل النص فارغ' ),
								required : false,
								onShow : function()
								{
									this.setValue(data.selected);
								},
								commit : function( data )
								{
									data.selected = this.getValue();
								}
							},{
								type: 'html',
								html: '<center>يمكنك ايضا التعديل على النص</center>'
								
							}
						]
					}
				],
				onOk : function()
				{
					this.commitContent(data);
					editor.insertHtml('[bor=' + data.color + ']' + data.selected + '[/bor]');
				}
			};
		});
	}
});